
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <errno.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <semaphore.h>
#include <ti/sdo/edma3/drv/edma3_drv.h>
#include "mpm_transport.h"

/*******************************************************************************************************************/
sem_t mutex;
/*******************************************************************************************************************/
void btl_hlink_dma_copy (mpm_transport_h *h, uint32_t dest, uint32_t source, uint32_t buff_size)
{
 mpm_transport_trans_h th1;
   th1 = mpm_transport_put_initiate(h, dest, source, buff_size, false, NULL);
   while(mpm_transport_transfer_check(h, th1) != 1);
}
/*******************************************************************************************************************/
void btl_hlink_dma_linked_copy (mpm_transport_h *h, uint32_t num_links, uint32_t dest[], uint32_t source[], uint32_t buff_size[])
{
 mpm_transport_trans_h th1;
   th1 = mpm_transport_put_initiate_linked(h, num_links, dest, source, buff_size, false, NULL);
   while(mpm_transport_transfer_check(h, th1) != 1);
}
/*******************************************************************************************************************/
void edma3OsProtectEntry (unsigned int edma3InstanceId, int level, unsigned int *intState)
{
}

void edma3OsProtectExit (unsigned int edma3InstanceId,
                        int level, unsigned int intState) {}

EDMA3_DRV_Result Edma3_CacheInvalidate(unsigned int mem_start_ptr,
                           unsigned int    num_bytes) {return EDMA3_DRV_SOK;}

EDMA3_DRV_Result Edma3_CacheFlush(unsigned int mem_start_ptr,
                      unsigned int num_bytes) {return EDMA3_DRV_SOK;}

EDMA3_DRV_Result edma3OsSemCreate() 
{
    sem_init(&mutex, 0, 1);
    return EDMA3_DRV_SOK;
}

EDMA3_DRV_Result edma3OsSemDelete() 
{
    sem_destroy(&mutex);
    return EDMA3_DRV_SOK;
}

EDMA3_DRV_Result edma3OsSemTake(EDMA3_OS_Sem_Handle hSem, int32_t mSecTimeout) 
{
    sem_post(&mutex);
    return EDMA3_DRV_SOK;
}

EDMA3_DRV_Result edma3OsSemGive(EDMA3_OS_Sem_Handle hSem) 
{
    sem_wait(&mutex);
    return EDMA3_DRV_SOK;
}


/*******************************************************************************************************************/
