#ifndef BTL_SRIO_FIFO_H
#define BTL_SRIO_FIFO_H
///////////////////////////////////////////////////////////////////////////////////////////
struct srio_fifo_t {
    unsigned int qsize;
    unsigned int base_payload_addr;
    unsigned int fragment_size;
    unsigned int head_cnt;
    unsigned int tail_cnt;
};

typedef struct srio_fifo_t srio_fifo_t;

typedef struct {
  unsigned int update_cnt;
  unsigned int remote_addr;
  int fd;
  int destid;
  srio_fifo_t rmt_fifo;
} srio_write_fifo_t;

void *srio_read_fifo_init(void *fifo_address, unsigned int base_payload_addr, unsigned int fragment_size, int fifo_size);
void *srio_write_fifo_init (int fd, int destid, unsigned int remote_addr);
int srio_fifo_write(void *loc_fifo_p, void *buffer, int len);
int srio_fifo_read_begin(void *fifo_ptr);
void srio_fifo_read_end(void *fifo_ptr);
#endif
/*** nothing past this point ***/
