export OPAL_PREFIX=${TARGET_ROOTDIR}/opt/ti-openmpi
export PATH:=${TARGET_ROOTDIR}/opt/ti-openmpi/bin:$(PATH)
export LD_LIBRARY_PATH=${TARGET_ROOTDIR}/opt/ti-openmpi/lib:${TARGET_ROOTDIR}/lib
export C_INCLUDE_PATH=${TARGET_ROOTDIR}/opt/ti-openmpi/include


UNAME_M :=$(shell uname -m)

MPICC=mpicc

ifneq (,$(findstring 86, $(UNAME_M)))
    .DEFAULT_GOAL := cross

    # In a cross compile environment we are assuming that the EVM file system
    # is located on the build host and necessary ARM libraries are installed
    # on that file system. 
    ifneq ($(MAKECMDGOALS),clean)
       ifeq ($(TARGET_ROOTDIR),)
         $(error Environment variable TARGET_ROOTDIR must be defined. Set it to point at the EVM root file system)
       endif
    endif

    # gcc ARM cross compiler will not, by default, search the host's
    # /usr/include.  Explicitly specify here to find dependent vendor headers
    cross: override CPP = arm-linux-gnueabihf-g++ -I$(TARGET_ROOTDIR)/usr/include -idirafter /usr/include

    # If cross-compilineg, provide path to dependent ARM libraries on the 
    # target filesystem
    cross: LD_FLAGS = -Wl,-rpath-link,$(TARGET_ROOTDIR)/opt/ti-openmpi/lib
endif

$(EXE):

cross: $(EXE)

clean:
	@rm -f $(EXE) *.o

