/* C Example */
#include <stdio.h>
#include <mpi.h>

int main (int argc, char *argv[])
{  
  int rank, size;
  MPI_Init (&argc, &argv);
  /* starts MPI */
  MPI_Comm_rank (MPI_COMM_WORLD, &rank);
  /* get current process id */
  MPI_Comm_size (MPI_COMM_WORLD, &size);
  /* get number of processes */

{
/* Get the name of the processor */
  char processor_name[320];
  int name_len;
  MPI_Get_processor_name(processor_name, &name_len);
 
  printf("Hello world from processor %s, rank %d out of %d processors\n", processor_name, rank, size);
  gethostname(processor_name, 320);
  printf ("locally obtained hostname %s\n", processor_name);

}

  MPI_Finalize();
  return 0;
}
